* Keep the necessary data to perform the regressions
keep  state id year sample pop nomexp child lnrexppch lnrincpc percurb percblack slandtop20 dlnrexppch dslandtop20_t1 dlnrincpc_t1 dpercblack_t1 dpercurb_t1 stemp srain sheat pcotwheat pcotcorn

* Table 2: Specifications for Changes in Per Child Education Expenditure
*     - The sample dummy just limits the regressions to observations with full data
reg dlnrexppch dslandtop20_t1 if sample==1, cluster(id)
reg dlnrexppch dslandtop20_t1 dlnrincpc_t1 if sample==1, cluster(id)
reg dlnrexppch dslandtop20_t1 dlnrincpc_t1 dpercblack_t1 if sample==1, cluster(id)
reg dlnrexppch dslandtop20_t1 dlnrincpc_t1 dpercblack_t1 dpercurb_t1 if sample==1, cluster(id)
reg dlnrexppch dslandtop20_t1 dlnrincpc_t1 dpercblack_t1 dpercurb_t1 year if sample==1, cluster(id)
xtreg dlnrexppch dslandtop20_t1 dlnrincpc_t1 dpercblack_t1 dpercurb_t1 if sample==1, fe cluster(id)

* Table 2 - Hausman test comparing fixed effects (column 6) to random effects
quietly {
xtreg dlnrexppch dslandtop20_t1 dlnrincpc_t1 dpercblack_t1 dpercurb_t1 if sample==1, fe robust
estimates store fe_results
xtreg dlnrexppch dslandtop20_t1 dlnrincpc_t1 dpercblack_t1 dpercurb_t1 if sample==1, re robust
estimates store re_results
}
hausman fe_results re_results 

* Generate the instrumental variables
*   - 'pca' does the principal component analysis
*   - 'predict' generates the first two components from the climate data
*   - The IV's are then created by multiplying the price data by the climate components
pca stemp srain sheat
predict clim1 clim2
gen iv1 = clim1*pcotcorn  
gen iv2 = clim2*pcotcorn

* Difference and lag the instrumental variables
quietly {
sort state year
gen iv1_t1=iv1[_n-1] 
replace iv1_t1=. if id~=id[_n-1]
gen iv1_t2=iv1[_n-2]
replace iv1_t2=. if id~=id[_n-2]
gen iv2_t1=iv2[_n-1]
replace iv2_t1=. if id~=id[_n-1]
gen iv2_t2=iv2[_n-2]
replace iv2_t2=. if id~=id[_n-2]
gen div1_t1 = iv1_t1 - iv1_t2
gen div2_t1 = iv2_t1 - iv2_t2
label variable iv1 "First climate/price instrumental variable"  
label variable iv2 "Second climate/price instrumental variable"
label variable div1_t1 "Diff in lag of first IV"
label variable div2_t1 "Diff in lag of second IV"
}

* Table 3: Instrumental Variable specifications
reg dlnrexppch dslandtop20_t1 dlnrincpc_t1 dpercblack_t1 dpercurb_t1 year if sample==1, cluster(id)
ivreg2 dlnrexppch (dslandtop20_t1 = div1_t1 div2_t1) dlnrincpc_t1 dpercblack_t1 dpercurb_t1 year if sample==1, cluster(id) first
